//
//  ViewController.m
//  BLE232Sample
//
//  Created by Wilson on 2017/1/11.
//  Copyright © 2017年 Wilson. All rights reserved.
//

#import "ViewController.h"

//#define UUID_1800_SERV @"00001800-0000-1000-8000-00805F9B34FB"
//#define UUID_1800_NAME @"00002A00-0000-1000-8000-00805F9B34FB"//6bytes
//#define UUID_180A_SERV @"0000180A-0000-1000-8000-00805F9B34FB"
#define UUID_180A_VER @"00002A26-0000-1000-8000-00805F9B34FB"//x.x.x
#define UUID_180A_MOD @"00002A24-0000-1000-8000-00805F9B34FB"//x.x.x
//#define UUID_NOTIFY @"00002902-0000-1000-8000-00805F9B34FB"//20bytes
#define UUID_232_SERV @"0003ABCD-0000-1000-8000-00805F9B0131"
#define UUID_BLE5DATA @"00031201-0000-1000-8000-00805F9B0130"
#define UUID_BLE5SENT @"00031202-0000-1000-8000-00805F9B0130"//20bytes
#define UUID_BLE5CONF @"00031203-0000-1000-8000-00805F9B0130"//4bytes
#define UUID_BLE5ADDR @"00031204-0000-1000-8000-00805F9B0130"//6bytes
#define UUID_BLE5NAME @"00031205-0000-1000-8000-00805F9B0130"//15bytes
#define UUID_BLE5PIN  @"00031206-0000-1000-8000-00805F9B0130"//6bytes
#define UUID_BLE5RBT  @"00031210-0000-1000-8000-00805F9B0130"//2byte




@interface ViewController ()
@property (weak, nonatomic) IBOutlet UITableView *tableBLE232;
@property (weak, nonatomic) IBOutlet UILabel *textState;
@property (weak, nonatomic) IBOutlet UIButton *btnClose;
@property (weak, nonatomic) IBOutlet UISegmentedControl *segmentedMode;

@property (weak, nonatomic) IBOutlet UIView *viewData;
@property (weak, nonatomic) IBOutlet UITextView *txtWrite;
@property (weak, nonatomic) IBOutlet UITextView *txtRead;
@property (weak, nonatomic) IBOutlet UIButton *btnWrite;
@property (weak, nonatomic) IBOutlet UIButton *btnClear;

@property (weak, nonatomic) IBOutlet UIButton *btnSetup232;
@property (weak, nonatomic) IBOutlet UIView *viewSetup;
@property (weak, nonatomic) IBOutlet UIView *viewSetup232;
@property (weak, nonatomic) IBOutlet UIView *viewSetupName;
@property (weak, nonatomic) IBOutlet UIView *viewSetupPIN;
@property (weak, nonatomic) IBOutlet UIView *viewSetupMAC;
@property (weak, nonatomic) IBOutlet UITableView *tablePeripheral;
@property (weak, nonatomic) IBOutlet UITextField *textName;
@property (weak, nonatomic) IBOutlet UITextField *textConfig;
@property (weak, nonatomic) IBOutlet UITextField *textPIN;
@property (weak, nonatomic) IBOutlet UITextField *textMAC;
@property (weak, nonatomic) IBOutlet UIButton *btnBaudRate;
@property (weak, nonatomic) IBOutlet UIButton *btnDataBites;
@property (weak, nonatomic) IBOutlet UIButton *btnStopBit;
@property (weak, nonatomic) IBOutlet UIButton *btnParityBit;
@property (weak, nonatomic) IBOutlet UIButton *btnFlowControl;
@property (weak, nonatomic) IBOutlet UIButton *btnSubmit;
@property (weak, nonatomic) IBOutlet UIButton *btnSetupMAC;
@property (weak, nonatomic) IBOutlet UIButton *btnReset;

@property (strong, nonatomic) CBCentralManager *centralManager;
@property (strong, nonatomic) CBPeripheral *connectPeripheral;;
@property (strong, nonatomic) NSMutableDictionary *bleList;
@property (strong, nonatomic) NSString *bleName;
@property (strong, nonatomic) CBCharacteristic *characteristicReadName;
@property (strong, nonatomic) CBCharacteristic *characteristicReadVer;
@property (strong, nonatomic) CBCharacteristic *characteristicReadMod;
@property (strong, nonatomic) CBCharacteristic *characteristicRead;
@property (strong, nonatomic) CBCharacteristic *characteristicWrite;
@property (strong, nonatomic) CBCharacteristic *characteristicConfig;
@property (strong, nonatomic) CBCharacteristic *characteristicMacAddress;
@property (strong, nonatomic) CBCharacteristic *characteristicDeviceName;
@property (strong, nonatomic) CBCharacteristic *characteristicReboot;
@property (strong, nonatomic) CBCharacteristic *characteristicPinCode;
@property (strong, nonatomic) NSData *rxData;
@property (strong, nonatomic) NSData *txData;
@property unsigned char *txByte;
@property (strong, nonatomic) NSString *DeviceName;
@property BOOL isRS232;
@property Byte ProductType;



@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.bleList=[NSMutableDictionary new];
    self.rxData=[[NSData alloc] init];
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}


- (void)viewDidAppear:(BOOL)animated{
    [self bleScan];
}
- (void) viewDidDisappear:(BOOL)animated{
    [self bleRelease];
}




- (IBAction)onclickCloseButton:(id)sender {
    if(!self.tableBLE232.isHidden){
        exit(0);
        return;
    }
    [self bleRelease];
    [self.tableBLE232 setHidden:NO];
    [self.viewSetup setHidden:YES];
    [self.viewData setHidden:YES];
    [self.segmentedMode setEnabled:NO];
    [self bleScan];
}

- (IBAction)segmentedValueChange:(id)sender {
    switch([sender selectedSegmentIndex]){
        case 0:
            [self.viewSetup setHidden:NO];
            [self.viewData setHidden:YES];
            [self.connectPeripheral setNotifyValue: NO forCharacteristic: self.characteristicRead];
            [self.viewSetup232 setHidden:YES];
            [self.viewSetupName setHidden:YES];
            [self.viewSetupPIN setHidden:YES];
            [self.viewSetupMAC setHidden:YES];
            [self.connectPeripheral readValueForCharacteristic: self.characteristicConfig];
            break;
        case 1:
            [self.viewSetup setHidden:YES];
            [self.viewData setHidden:NO];
            [self.connectPeripheral setNotifyValue: YES forCharacteristic: self.characteristicRead];
            break;
    }
}

- (IBAction)onclickClearButton:(id)sender {
    self.rxData=[NSData data];
    [self.txtRead setText:@""];
}

- (IBAction)onclickWriteButton:(id)sender {
    [[[UIApplication sharedApplication] keyWindow] endEditing:YES];
    self.txData=[self.txtWrite.text dataUsingEncoding:NSUTF8StringEncoding];
    [self.btnWrite setEnabled:NO];
    [self writeData];
}
-(void)writeData{
    NSData *tmpData;
    long n=self.txData.length;
    if(n==0){
        [self.txtWrite setText:@""];
        [self.btnWrite setEnabled:YES];
        return;
    }else if(n>20){
        tmpData=[self.txData subdataWithRange:NSMakeRange(0,20)];
        self.txData=[NSData dataWithData:[self.txData subdataWithRange:NSMakeRange(20,n-20)]];
    }else{
        tmpData=[self.txData subdataWithRange:NSMakeRange(0,n)];
        self.txData=[NSData data];
    }
    [self.connectPeripheral writeValue:tmpData
                     forCharacteristic:self.characteristicWrite
                                  type:CBCharacteristicWriteWithResponse];
}


- (IBAction)onClickSetup232:(id)sender {
    [[[UIApplication sharedApplication] keyWindow] endEditing:YES];
    [self.viewSetup232 setHidden:!self.viewSetup232.isHidden];
    [self.viewSetupName setHidden:YES];
    [self.viewSetupPIN setHidden:YES];
    [self.viewSetupMAC setHidden:YES];
    if(self.viewSetup232.isHidden)return;
    [self.connectPeripheral readValueForCharacteristic:self.characteristicConfig];
}
- (IBAction)onClickSetupName:(id)sender {
    [[[UIApplication sharedApplication] keyWindow] endEditing:YES];
    [self.viewSetup232 setHidden:YES];
    [self.viewSetupName setHidden:!self.viewSetupName.isHidden];
    [self.viewSetupPIN setHidden:YES];
    [self.viewSetupMAC setHidden:YES];
    if(self.viewSetupName.isHidden)return;
    [self.connectPeripheral readValueForCharacteristic:self.characteristicDeviceName];
}
- (IBAction)onClickSetupPIN:(id)sender {
    [[[UIApplication sharedApplication] keyWindow] endEditing:YES];
    [self.viewSetup232 setHidden:YES];
    [self.viewSetupName setHidden:YES];
    [self.viewSetupPIN setHidden:!self.viewSetupPIN.isHidden];
    [self.viewSetupMAC setHidden:YES];
    if(self.viewSetupPIN.isHidden)return;
    [self.connectPeripheral readValueForCharacteristic:self.characteristicPinCode];
}
- (IBAction)onClickSetupMAC:(id)sender {
    [[[UIApplication sharedApplication] keyWindow] endEditing:YES];
    [self.viewSetup232 setHidden:YES];
    [self.viewSetupName setHidden:YES];
    [self.viewSetupPIN setHidden:YES];
    [self.viewSetupMAC setHidden:!self.viewSetupMAC.isHidden];
    if(self.viewSetupMAC.isHidden){
        [self.centralManager stopScan];
    }else{
        [self.connectPeripheral readValueForCharacteristic:self.characteristicMacAddress];
        [self.bleList removeAllObjects];
        [self.tablePeripheral reloadData];
        [self bleScan];
    }
}
- (IBAction)onClickReset:(id)sender {
    [[[UIApplication sharedApplication] keyWindow] endEditing:YES];
    unsigned char p[2]={self.ProductType,0x10};
    [self.connectPeripheral writeValue:[NSData dataWithBytes:&p length:2] forCharacteristic:self.characteristicReboot
           type:CBCharacteristicWriteWithResponse];
}

- (IBAction)onClickDFU:(id)sender {
    [[[UIApplication sharedApplication] keyWindow] endEditing:YES];
    unsigned char p[2]={self.ProductType,0x1A};
    [self.connectPeripheral writeValue:[NSData dataWithBytes:&p length:2] forCharacteristic:self.characteristicReboot
           type:CBCharacteristicWriteWithResponse];
}






































- (IBAction)onClickReboot:(id)sender{
    [[[UIApplication sharedApplication] keyWindow] endEditing:YES];
    unsigned char p[2]={self.ProductType,0x80};
    [self.connectPeripheral writeValue:[NSData dataWithBytes:&p length:2] forCharacteristic:self.characteristicReboot
           type:CBCharacteristicWriteWithResponse];
}

- (IBAction)onClickRename:(id)sender {
    NSData *tmpData=[self.textName.text dataUsingEncoding:NSUTF8StringEncoding];
    [self.connectPeripheral writeValue:tmpData forCharacteristic: self.characteristicDeviceName type:CBCharacteristicWriteWithResponse];
    [self.viewSetupName setHidden:YES];
    UIAlertController *alert=[UIAlertController alertControllerWithTitle:@"Reboot" message:@"Reboot to change Name." preferredStyle:UIAlertControllerStyleAlert];
    [alert addAction:[UIAlertAction actionWithTitle:@"OK"
                                    style:UIAlertActionStyleDestructive
            handler:^(UIAlertAction * _Nonnull action){
        [self onClickReboot:nil];
    }]];
    [self presentViewController:alert animated:NO completion:nil];
}
- (IBAction)onClickConfig:(id)sender {
    [self.connectPeripheral writeValue:[NSData dataWithBytes:self.txByte length:4] forCharacteristic:self.self.characteristicConfig type:CBCharacteristicWriteWithResponse];
    [self.viewSetup232 setHidden:YES];
}
- (IBAction)onClickSetPINCode:(id)sender {
    long n=self.textPIN.text.length;
    if(n==0){
        for(int i=0;i<6;i++) self.txByte[i]='0';
    }else if(n==6){
        const char *p=[self.textPIN.text UTF8String];
        for(int i=0;i<n;i++) self.txByte[i]=p[i];
        self.txByte[6]=0x01;
    }else{
        UIAlertController *alert=[UIAlertController alertControllerWithTitle:nil message:@"Please Input 6 Numbers." preferredStyle:UIAlertControllerStyleAlert];
        [self presentViewController:alert animated:YES completion:nil];
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, 2 * NSEC_PER_SEC), dispatch_get_main_queue(), ^{
            [alert dismissViewControllerAnimated:YES completion:nil];
        });
        return;
    }
    [self.connectPeripheral writeValue:[NSData dataWithBytes:self.txByte length:6] forCharacteristic:self.characteristicPinCode type:CBCharacteristicWriteWithResponse];
    UIAlertController *alert=[UIAlertController alertControllerWithTitle:@"PIN Code" message: n>0 ? @"Reboot to enable PIN code." : @"PIN Code is Disable." preferredStyle:UIAlertControllerStyleAlert];
    [alert addAction:[UIAlertAction actionWithTitle:@"OK"
                                    style:UIAlertActionStyleDestructive
                                    handler:^(UIAlertAction * _Nonnull action){
        [self onClickReboot:nil];
    }]];
    [self presentViewController:alert animated:NO completion:nil];
}
- (IBAction)onClickCentralMode:(id)sender {
    NSData *tmpData=[self hexString2NSData:self.textMAC.text];
    [self.connectPeripheral writeValue:tmpData
                     forCharacteristic:self.characteristicMacAddress
                                  type:CBCharacteristicWriteWithResponse];
    [self.centralManager stopScan];
    UIAlertController *alert=[UIAlertController alertControllerWithTitle:@"Reboot" message:@"Reboot to Central Mode." preferredStyle:UIAlertControllerStyleAlert];
    [alert addAction:[UIAlertAction actionWithTitle:@"Cancel"
                                    style:UIAlertActionStyleCancel
                                    handler:nil]];
    [alert addAction:[UIAlertAction actionWithTitle:@"OK"
                                    style:UIAlertActionStyleDestructive
                                    handler:^(UIAlertAction * _Nonnull action){
        unsigned char p[2]={self.ProductType,0x3A};
        [self.connectPeripheral writeValue:[NSData dataWithBytes:&p length:2] forCharacteristic:self.characteristicReboot type:CBCharacteristicWriteWithResponse];
    }]];
    [self presentViewController:alert animated:NO completion:nil];
}

-(NSData *)hexString2NSData:(NSString *)str{
    NSMutableData* data = [NSMutableData data];
    for(int i=0; i<str.length; i+=3) {
        NSString *hexStr=[str substringWithRange:NSMakeRange(i,2)];
        unsigned int intValue;
        [[NSScanner scannerWithString:hexStr] scanHexInt:&intValue];
        [data appendBytes:&intValue length:1];
    }
    return [NSData dataWithData:data];
}




- (IBAction)onClickSetBaudRate:(id)sender {
    UIAlertController *alert=[UIAlertController alertControllerWithTitle:@"Baud Rate" message:@"" preferredStyle:UIAlertControllerStyleAlert];
    [alert addAction:[UIAlertAction actionWithTitle:@"230400"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[1]=8;
        [self.btnBaudRate setTitle:@"BAUD RATE：230400" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"115200"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[1]=7;
        [self.btnBaudRate setTitle:@"BAUD RATE：115200" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"57600"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[1]=6;
        [self.btnBaudRate setTitle:@"BAUD RATE：57600" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"38400"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[1]=5;
        [self.btnBaudRate setTitle:@"BAUD RATE：38400" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"19200"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[1]=4;
        [self.btnBaudRate setTitle:@"BAUD RATE：19200" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"9600"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[1]=3;
        [self.btnBaudRate setTitle:@"BAUD RATE：9600" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"4800"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[1]=2;
        [self.btnBaudRate setTitle:@"BAUD RATE：4800" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"2400"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[1]=1;
        [self.btnBaudRate setTitle:@"BAUD RATE：2400" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"1200"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[1]=0;
        [self.btnBaudRate setTitle:@"BAUD RATE：1200" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"Cancel"
                                    style:UIAlertActionStyleCancel
                                    handler:nil]];
    [self presentViewController:alert animated:NO completion:nil];
}
//- (IBAction)onClickSetDataBits:(id)sender {
//    UIAlertController *alert=[UIAlertController alertControllerWithTitle:@"Data Bits"
//                                                message:@""
//                                                preferredStyle:UIAlertControllerStyleAlert];
//    [alert addAction:[UIAlertAction actionWithTitle:@"7"
//                                    style:UIAlertActionStyleDefault
//                                    handler:^(UIAlertAction * _Nonnull action){
//        self.txByte[0]=7;
//        [self.btnDataBites setTitle:@"DATA BITS：7" forState:UIControlStateNormal];
//        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X %02X %02X %02X",self.txByte[0],self.txByte[1],self.txByte[2],self.txByte[3],self.txByte[4],self.txByte[5],self.txByte[6]]];
//    }]];
//    [alert addAction:[UIAlertAction actionWithTitle:@"8"
//                                    style:UIAlertActionStyleDefault
//                                    handler:^(UIAlertAction * _Nonnull action){
//        self.txByte[0]=8;
//        [self.btnDataBites setTitle:@"DATA BITS：8" forState:UIControlStateNormal];
//        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X %02X %02X %02X",self.txByte[0],self.txByte[1],self.txByte[2],self.txByte[3],self.txByte[4],self.txByte[5],self.txByte[6]]];
//    }]];
//
//    [alert addAction:[UIAlertAction actionWithTitle:@"Cancel"
//                                    style:UIAlertActionStyleCancel
//                                    handler:nil]];
//    [self presentViewController:alert animated:NO completion:nil];
//}
//- (IBAction)onClickSetStopBit:(id)sender {
//    UIAlertController *alert=[UIAlertController alertControllerWithTitle:@"Stop Bit"
//                                                message:@""
//                                                preferredStyle:UIAlertControllerStyleAlert];
//    [alert addAction:[UIAlertAction actionWithTitle:@"1"
//                                    style:UIAlertActionStyleDefault
//                                    handler:^(UIAlertAction * _Nonnull action){
//        self.txByte[2]=2;
//        [self.btnStopBit setTitle:@"STOP BIT：1" forState:UIControlStateNormal];
//        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X %02X %02X %02X",self.txByte[0],self.txByte[1],self.txByte[2],self.txByte[3],self.txByte[4],self.txByte[5],self.txByte[6]]];
//    }]];
//    [alert addAction:[UIAlertAction actionWithTitle:@"1.5"
//                                    style:UIAlertActionStyleDefault
//                                    handler:^(UIAlertAction * _Nonnull action){
//        self.txByte[2]=3;
//        [self.btnStopBit setTitle:@"STOP BIT：1.5" forState:UIControlStateNormal];
//        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X %02X %02X %02X",self.txByte[0],self.txByte[1],self.txByte[2],self.txByte[3],self.txByte[4],self.txByte[5],self.txByte[6]]];
//    }]];
//    [alert addAction:[UIAlertAction actionWithTitle:@"2"
//                                    style:UIAlertActionStyleDefault
//                                    handler:^(UIAlertAction * _Nonnull action){
//        self.txByte[2]=4;
//        [self.btnStopBit setTitle:@"STOP BIT：2" forState:UIControlStateNormal];
//        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X %02X %02X %02X",self.txByte[0],self.txByte[1],self.txByte[2],self.txByte[3],self.txByte[4],self.txByte[5],self.txByte[6]]];
//    }]];
//
//    [alert addAction:[UIAlertAction actionWithTitle:@"Cancel"
//                                    style:UIAlertActionStyleCancel
//                                    handler:nil]];
//    [self presentViewController:alert animated:NO completion:nil];
//}
- (IBAction)onClickSetParity:(id)sender {
    UIAlertController *alert=[UIAlertController alertControllerWithTitle:@"Parity Bit" message:@"" preferredStyle:UIAlertControllerStyleAlert];
    [alert addAction:[UIAlertAction actionWithTitle:@"Even Parity"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[3]=(self.txByte[3]&0xFE)|0x01;
        [self.btnParityBit setTitle:@"PARITY BIT：Even" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"No Parity"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[3]=self.txByte[3]&0xFE;
        [self.btnParityBit setTitle:@"PARITY BIT：None" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"Cancel"
                                    style:UIAlertActionStyleCancel
                                    handler:nil]];
    [self presentViewController:alert animated:NO completion:nil];
}
- (IBAction)onClickSetFlowControl:(id)sender {
    UIAlertController *alert=[UIAlertController alertControllerWithTitle:@"Flow Control" message:@"" preferredStyle:UIAlertControllerStyleAlert];
    [alert addAction:[UIAlertAction actionWithTitle:@"Enable"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[3]=(self.txByte[3]&0xFD)|0x02;
        [self.btnFlowControl setTitle:@"FLOW CONTROL：Enable" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"Disable"
                                    style:UIAlertActionStyleDefault
                                    handler:^(UIAlertAction * _Nonnull action){
        self.txByte[3]=self.txByte[3]&0xFD;
        [self.btnFlowControl setTitle:@"FLOW CONTROL：Disable" forState:UIControlStateNormal];
        [self.textConfig setText:[NSString stringWithFormat:@"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"Cancel"
                                    style:UIAlertActionStyleCancel
                                    handler:nil]];
    [self presentViewController:alert animated:NO completion:nil];
}
















- (void) bleRelease{
    [self.btnClose setTitle:@"Close" forState:UIControlStateNormal];
    [self.textState setText:@"Select Device："];
    [self.segmentedMode setEnabled:NO];
    [self.viewSetup setHidden:YES];
    [self.viewData setHidden:YES];
    [self.centralManager stopScan];
    if(!self.connectPeripheral) return;
    [self.centralManager cancelPeripheralConnection:self.connectPeripheral];
    self.connectPeripheral=nil;
}


- (void) bleScan{
    if(!self.centralManager){
        self.centralManager=[[CBCentralManager alloc] initWithDelegate:self queue:nil];
    }
    
    //clear TableView
    [self.bleList removeAllObjects];
    [self.tableBLE232 reloadData];
    
    NSString *stateString;// = nil;
    switch(self.centralManager.state){
        default:
        case CBCentralManagerStateUnknown:
            return;
        case CBCentralManagerStateResetting:
            stateString = @"The connection with the system service was momentarily lost.";
            break;
        case CBCentralManagerStateUnsupported:
            stateString = @"The platform doesn't support Bluetooth Low Energy.";
            break;
        case CBCentralManagerStateUnauthorized:
            stateString = @"The app is not authorized to use Bluetooth Low Energy.";
            break;
        case CBCentralManagerStatePoweredOff:
            stateString = @"Bluetooth is currently powered off.";
            break;
        case CBCentralManagerStatePoweredOn:
            stateString = @"Bluetooth is currently powered on and available to use.";
            if(self.centralManager.isScanning) return;
            [self.centralManager stopScan];
            [self.centralManager scanForPeripheralsWithServices:nil options:nil];
            NSLog(@"startScan");
            return;
    }
    UIAlertController *alert=[UIAlertController alertControllerWithTitle:@"Bluetooth state"
                                                message:stateString
                                                preferredStyle:UIAlertControllerStyleAlert];
    [alert addAction:[UIAlertAction actionWithTitle:@"Okay"
                                    style:UIAlertActionStyleDefault
                                    handler:nil]];
    [self presentViewController:alert animated:true completion:nil];
}
-(void)centralManagerDidUpdateState:(CBCentralManager*)cManager{
    if(cManager.state==CBCentralManagerStatePoweredOn){
        [self.centralManager stopScan];
        [self.centralManager scanForPeripheralsWithServices:nil options:nil];
        NSLog(@"PoweredOn Scan");
    }
}
- (void)centralManager:(CBCentralManager *)central didDiscoverPeripheral:(CBPeripheral *)peripheral advertisementData:(NSDictionary *)advertisementData RSSI:(NSNumber *)RSSI {
    NSString *uuid=peripheral.identifier.UUIDString;
    if([[self.bleList allKeys] containsObject:uuid])return;//skip the same device
    NSString *localName=[advertisementData objectForKey:CBAdvertisementDataLocalNameKey];
    Byte *mac=(Byte *)[[advertisementData objectForKey:CBAdvertisementDataManufacturerDataKey] bytes];
    if(localName==nil || mac==NULL)return;
    NSMutableArray *bleInfo=[NSMutableArray new];
    if(sizeof(mac)==8 && mac[0]==0x59){
        [bleInfo addObject:[NSString stringWithFormat: @"%@/%02X:%02X:%02X:%02X:%02X:%02X", localName,mac[7],mac[6],mac[5],mac[4],mac[3],mac[2]]];
    }else return;//not our device
    [bleInfo addObject:peripheral];
    [self.bleList setObject:bleInfo forKey:uuid];
    [self.tableBLE232.isHidden?self.tablePeripheral:self.tableBLE232 reloadData];
}







-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [self.bleList count];
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *CellIdentifier = @"cellIdentifier";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc]
                initWithStyle:UITableViewCellStyleDefault
                reuseIdentifier:CellIdentifier];
    }
    cell.textLabel.text=[self.bleList objectForKey:[self.bleList allKeys][indexPath.row]][0];
    return cell;
}
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    if(tableView == self.tablePeripheral){
        NSString *mac=[self.bleList allKeys][indexPath.row];
        mac=[self.bleList objectForKey:mac][0];
        [self.textMAC setText:[NSString stringWithFormat: @"00:A0:51:%@", [mac substringFromIndex:mac.length-8]]];
        [tableView deselectRowAtIndexPath:indexPath animated:YES];
        return;
    }
    [self.centralManager stopScan];
    NSString *bleDevice = [self.bleList allKeys][indexPath.row];
    self.bleName=[self.bleList objectForKey:bleDevice][0];
    self.connectPeripheral=[self.bleList objectForKey:bleDevice][1];
    [self.centralManager connectPeripheral:self.connectPeripheral options:nil];
    [self.textState setText:[NSString stringWithFormat:@"%@\nConnecting...",self.bleName]];
    [self.tableBLE232 setHidden:YES];
    [self.btnClose setTitle:@"Back" forState:UIControlStateNormal];
}






-(void)centralManager:(CBCentralManager *)central didFailToConnect:(CBPeripheral *)peripheral error:(nullable NSError *)error{
    [self.textState setText:[NSString stringWithFormat:@"%@\nConnect Fail.",self.bleName]];
    [self.btnClose setTitle:@"Back" forState:UIControlStateNormal];
    [self.segmentedMode setEnabled:NO];
    [self.viewSetup setHidden:YES];
    [self.viewData setHidden:YES];
    [self.btnClose setEnabled:YES];
    self.connectPeripheral=nil;
}
-(void)centralManager:(CBCentralManager *)central didDisconnectPeripheral:(CBPeripheral *)peripheral error:(NSError *)error {
    [self.textState setText:@"Select Device："];
    [self.segmentedMode setEnabled:NO];
    [self.viewSetup setHidden:YES];
    [self.viewData setHidden:YES];
    [self.tableBLE232 setHidden:NO];
    [self bleScan];
}
-(void)centralManager:(CBCentralManager *)central didConnectPeripheral:(CBPeripheral *)peripheral {
    peripheral.delegate=self;
    [peripheral discoverServices:nil];
    self.characteristicReadMod=nil;
    self.characteristicReadVer=nil;
    self.characteristicWrite=nil;
    self.characteristicConfig=nil;
    self.characteristicMacAddress=nil;
    self.characteristicDeviceName=nil;
    self.characteristicPinCode=nil;
    self.characteristicReboot=nil;
    self.characteristicRead=nil;
}
- (void)peripheral:(CBPeripheral *)peripheral didDiscoverServices:(NSError *)error {
    NSLog(@"didDiscoverServices:\n");
    if( peripheral.identifier == NULL  ) return;
    if (!error) {
        NSLog(@"====%@\n",peripheral.name);
        NSLog(@"=========== %ld of service for UUID %@ ===========\n",(long)peripheral.services.count,peripheral.identifier.UUIDString);
        
        for (CBService *p in peripheral.services){
            NSLog(@"Service found with UUID: %@\n", p.UUID);
            [peripheral discoverCharacteristics:nil forService:p];
        }
        
    }
    else {
        NSLog(@"Service discovery was unsuccessfull !\n");
    }
    
}
//
-(void)peripheral:(CBPeripheral *)peripheral didDiscoverCharacteristicsForService:(CBService *)service error:(NSError *)error
{
    CBService *s = [peripheral.services objectAtIndex:(peripheral.services.count - 1)];
    if(service.UUID == NULL || s.UUID == NULL) return;
    //NSLog(@"=========== Service UUID %s ===========\n",[NSUUID UUID] ini);
    if(error){
        NSLog(@"Characteristic discorvery unsuccessfull !\n");
    }else{
        NSLog(@"=========== %ld Characteristics of %@ service ",(long)service.characteristics.count,service.UUID);
        for(CBCharacteristic *c in service.characteristics){
            if([c.UUID isEqual:[CBUUID UUIDWithString:UUID_180A_VER]]) {
                self.characteristicReadVer=c;
            }else if([c.UUID isEqual:[CBUUID UUIDWithString:UUID_180A_MOD]]) {
                self.characteristicReadMod=c;
            }else if([c.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5DATA]]) {
                self.characteristicRead=c;
            }else if([c.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5SENT]]) {
                self.characteristicWrite=c;
            }else if([c.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5CONF]]) {
                self.characteristicConfig=c;
            }else if([c.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5ADDR]]) {
                self.characteristicMacAddress=c;
            }else if([c.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5NAME]]) {
                self.characteristicDeviceName=c;
            }else if([c.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5RBT]]) {
                self.characteristicReboot=c;
            }else if([c.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5PIN]]) {
                self.characteristicPinCode=c;
            }
        }
        if(self.characteristicReadMod &&
           self.characteristicReadVer &&
           self.characteristicWrite &&
           self.characteristicConfig &&
           self.characteristicMacAddress &&
           self.characteristicDeviceName &&
           self.characteristicPinCode &&
           self.characteristicReboot &&
           self.characteristicRead){
            [peripheral readValueForCharacteristic: self.characteristicReadVer];
        }
    }
}


- (void)peripheral:(CBPeripheral *)peripheral didUpdateValueForCharacteristic:(CBCharacteristic *)characteristic error:(NSError *)error{
    if([characteristic.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5DATA]]){
        NSMutableData* data=[NSMutableData dataWithData:self.rxData];
        [data appendData:characteristic.value];
        self.rxData=data;
        NSString *str=[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
        [self.txtRead setText:str];
    }else if([characteristic.UUID isEqual:[CBUUID UUIDWithString:UUID_180A_VER]]){
        NSString *str=[[NSString alloc] initWithData:characteristic.value encoding:NSUTF8StringEncoding];
        self.DeviceName=peripheral.name;
        [self.textState setText:[NSString stringWithFormat:@"%@\nConnected.(Ver:%@", self.bleName, str]];
        [peripheral readValueForCharacteristic:self.characteristicReadMod];
    }else if([characteristic.UUID isEqual:[CBUUID UUIDWithString:UUID_180A_MOD]]){
        NSString *str=[[NSString alloc] initWithData:characteristic.value encoding:NSUTF8StringEncoding];
        NSRange r=[str rangeOfString:@"5.0"];
        if(r.location>0){
            self.DeviceName=[str substringToIndex:r.location-1];
            str=[str substringFromIndex:r.location];
        }
        self.isRS232=[self.DeviceName isEqualToString:@"BLE232"];
        [self.textState setText:[NSString stringWithFormat:@"%@ %@)[%@]", self.textState.text,self.DeviceName,str]];
        [self.btnFlowControl setHidden:!self.isRS232];
 
        [self.segmentedMode setEnabled:YES];
        [self.segmentedMode setSelectedSegmentIndex:0];
        [self segmentedValueChange:self.segmentedMode];
        [self.txtWrite setText:@""];
        [self onclickClearButton:nil];
        [self.btnClose setEnabled:YES];
        
    }else if([characteristic.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5CONF]]){
        NSString *s=@"";
        if(characteristic.value.length==4){
            self.txByte=(Byte *)[characteristic.value bytes];
            self.ProductType=self.txByte[0];
            
            s=@"BAUD RATE：";
            switch(self.txByte[1]){//Baud Rate
                default:self.txByte[1]=3;
                case 3:s=@"BAUD RATE：9600";break;
                case 0:s=@"BAUD RATE：1200";break;
                case 1:s=@"BAUD RATE：2400";break;
                case 2:s=@"BAUD RATE：4800";break;
                case 4:s=@"BAUD RATE：19200";break;
                case 5:s=@"BAUD RATE：38400";break;
                case 6:s=@"BAUD RATE：57600";break;
                case 7:s=@"BAUD RATE：115200";break;
                case 8:s=@"BAUD RATE：230400";break;
            }
            [self.btnBaudRate setTitle:s forState:UIControlStateNormal];
            self.txByte[2]=0;//Not Used

//      bit3:PortType(0:RS485/1:RS422) *Only on RS485/RS422 Product
//      bit4:BLE Role(0:Peripheral/1:Central) *indication Only
//      bit5:ControlSet(0:Configurable/1:Fixed By Hardware) *indication Only
            BOOL sMode = (self.txByte[3]&0x20)==0;//Software mode
            [self.btnSetup232 setTitle:sMode?@"SERIAL PORT":@"HARDWARE SETTING" forState:UIControlStateNormal];
//      bit0(HardwareMode在bit3):ParityBit:(0:NONE/1:EVEN)
            s=(self.txByte[3]&(sMode?0x01:0x08))>0?@"PARITY BIT：Even":@"PARITY BIT：None";
            [self.btnParityBit setTitle:s forState:UIControlStateNormal];
            s=@"DATA BITS：8";
            [self.btnDataBites setTitle:s forState:UIControlStateNormal];
            [self.btnDataBites setEnabled:NO];
//            [self.btnDataBites setTitleColor:[UIColor lightGrayColor] forState:UIControlStateNormal];
            s=@"STOP BIT：1";
            [self.btnStopBit setTitle:s forState:UIControlStateNormal];
            [self.btnStopBit setEnabled:NO];
//            [self.btnStopBit setTitleColor:[UIColor lightGrayColor] forState:UIControlStateNormal];
//      bit1(HardwareMode在bit2):FlowControl(0:Disabled/1:Enabled) *RS232 Only
            s=(self.txByte[3]&(sMode?0x02:0x04))>0?@"FLOW CONTROL：Enable":@"FLOW CONTROL：Disable";
            [self.btnFlowControl setTitle:s forState:UIControlStateNormal];

//      bit3:PortType(0:RS485/1:RS422) *Only on RS485/RS422 Product
            if( !self.isRS232 && (self.txByte[3]&0x08)>0 ){
                s = [self.textState.text stringByReplacingOccurrencesOfString:@"BLE485)" withString:@"BLE422)"];
                [self.textState setText:s];
            }
            [self.textConfig setText:[NSString stringWithFormat: @"%02X %02X %02X %02X", self.txByte[0], self.txByte[1], self.txByte[2], self.txByte[3]]];

            [self.btnBaudRate setEnabled:sMode];
//            [self.btnBaudRate setTitleColor:sMode?[UIColor blueColor] : [UIColor lightGrayColor] forState:UIControlStateNormal];
            [self.btnParityBit setEnabled:sMode];
//            [self.btnParityBit setTitleColor:sMode?[UIColor blueColor] : [UIColor lightGrayColor] forState:UIControlStateNormal];
            [self.btnFlowControl setEnabled:sMode];
//            [self.btnFlowControl setTitleColor:sMode?[UIColor blueColor] : [UIColor lightGrayColor] forState:UIControlStateNormal];
            [self.textConfig setHidden:!sMode];
            [self.btnSubmit setHidden:!sMode];
            
        }else [self.textConfig setText:@""];
    }else if([characteristic.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5ADDR]]){
        if(characteristic.value.length==6){
            unsigned char d[6];
            [characteristic.value getBytes:&d length:6];
            [self.textMAC setText:[NSString stringWithFormat: @"%02X:%02X:%02X:%02X:%02X:%02X", d[0],d[1],d[2],d[3],d[4],d[5]]];
        }else [self.textMAC setText:@""];
    }else if([characteristic.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5NAME]]){
        NSString *str=[[NSString alloc] initWithData:characteristic.value encoding:NSUTF8StringEncoding];
        NSRange r=[str rangeOfString:@"\0"];
        [self.textName setText:[str substringToIndex: r.length>0 ? r.location : str.length]];
    }else if([characteristic.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5PIN]]){
        self.txByte=(Byte *)[characteristic.value bytes];
        [self.textPIN setText:[NSString stringWithFormat: @"%c%c%c%c%c%c", self.txByte[0],self.txByte[1],self.txByte[2], self.txByte[3],self.txByte[4],self.txByte[5]]];
    }
}

- (void)peripheral:(CBPeripheral *)peripheral didWriteValueForCharacteristic:(CBCharacteristic *)characteristic error:(NSError *)error{
    if([characteristic.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5SENT]]){
        [self writeData];
    }else if([characteristic.UUID isEqual:[CBUUID UUIDWithString:UUID_BLE5RBT]]){
        [self onclickCloseButton:nil];//斷線
    }
}
//Called after a setNotificationStateForCharacteristic is called.
- (void)peripheral:(CBPeripheral *)peripheral didUpdateNotificationStateForCharacteristic:(CBCharacteristic *)characteristic error:(NSError *)error{
}










- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)txt{
    NSUInteger newLength = (textField.text.length-range.length)+txt.length;
    if(textField == self.textName){
        if(newLength>15)
            return NO;
    }else if(textField == self.textPIN){
        if(newLength>6)
            return NO;
    }
    return YES;
}

//hide soft keybord
-(BOOL)textFieldShouldReturn:(UITextField *)textField{
    if([textField isFirstResponder])
        [textField resignFirstResponder];
    return YES;
}
-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    [self.textName resignFirstResponder];
    [self.textPIN resignFirstResponder];
    [self.txtWrite resignFirstResponder];
    [super touchesBegan:touches withEvent:event];
}



@end
