package tw.com.uconnect.ble5serial;


import android.Manifest;
import android.annotation.SuppressLint;
import android.annotation.TargetApi;
import android.app.Activity;
import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothGatt;
import android.bluetooth.BluetoothGattCallback;
import android.bluetooth.BluetoothGattCharacteristic;
import android.bluetooth.BluetoothGattDescriptor;
import android.bluetooth.BluetoothGattService;
import android.bluetooth.BluetoothProfile;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class MainActivity extends Activity {

    private static final int REQUEST_ENABLE_BT = 1;
    private static final int MY_PERMISSIONS_REQUEST=1;
    private static Handler handler=new Handler();

    private Context context;
    private BluetoothAdapter mBluetoothAdapter;
    private final long SCAN_PERIOD = 5000; // Stops scanning after 5 seconds
    private List<String> ListData=new ArrayList<String>();

    private BluetoothDevice mBluetoothDevice;
    private BluetoothGatt   mBluetoothGatt;
    private String bleDevice;
    private byte[] rxValue={};
    private byte[] txValue={};
    private String[] array232;
    private String DeviceName;
    private String bleFilter="00:A0:51";
    private boolean isRS232;
    private byte ProductType;

    private WriteQueue writeQueue = new WriteQueue();
    private final static UUID
    UUID_1800_SERV = UUID.fromString("00001800-0000-1000-8000-00805F9B34FB"),
    UUID_1800_NAME = UUID.fromString("00002A00-0000-1000-8000-00805F9B34FB"),//15byte
    UUID_180A_SERV = UUID.fromString("0000180A-0000-1000-8000-00805F9B34FB"),
    UUID_180A_VER  = UUID.fromString("00002A26-0000-1000-8000-00805F9B34FB"),//x.x.x(ASCII/read only)
    UUID_180A_MOD  = UUID.fromString("00002A24-0000-1000-8000-00805F9B34FB"),//x.x.x(ASCII/read only)
    UUID_NOTIFY    = UUID.fromString("00002902-0000-1000-8000-00805F9B34FB"),//20byte

    UUID_BLE_SERV = UUID.fromString("0003ABCD-0000-1000-8000-00805F9B0131"),
    UUID_BLE5DATA = UUID.fromString("00031201-0000-1000-8000-00805f9b0130"),
    UUID_BLE5SENT = UUID.fromString("00031202-0000-1000-8000-00805f9b0130"),//20bytes
    UUID_BLE5CONF = UUID.fromString("00031203-0000-1000-8000-00805f9b0130"),//4bytes
    UUID_BLE5ADDR = UUID.fromString("00031204-0000-1000-8000-00805f9b0130"),//6bytes
    UUID_BLE5NAME = UUID.fromString("00031205-0000-1000-8000-00805f9b0130"),//15bytes
    UUID_BLE5PIN  = UUID.fromString("00031206-0000-1000-8000-00805f9b0130"),//6bytes
    UUID_BLE5RBT  = UUID.fromString("00031210-0000-1000-8000-00805f9b0130");//2bytes


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        context=this;
        handler=initMessage();
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        if(mBluetoothAdapter == null){
            Toast.makeText(this,"Bluetooth is not available.",Toast.LENGTH_LONG).show();
            finish();
            return;
        }


        ((ListView)findViewById(R.id.listViewDevice)).setAdapter(new ArrayAdapter<String>(this,0,ListData)
        {@SuppressLint("InflateParams") @Override public View getView(int position, View v, ViewGroup parent){
            if(v==null)v=getLayoutInflater().inflate(android.R.layout.simple_list_item_1,null);
            ((TextView)v).setText(getItem(position));
            v.setOnClickListener(new View.OnClickListener()
            {@Override public void onClick(View v){
                scanLeDevice(false);
                bleDevice=((TextView)v).getText().toString();
                handler.sendEmptyMessage(100);//Connect BleDevice
            }});
            return v;
        }});

        findViewById(R.id.btnClose).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            v.setEnabled(false);
            findViewById(R.id.listViewDevice).setVisibility(View.VISIBLE);
            ((TextView)findViewById(R.id.textViewInfo)).setText("");
            findViewById(R.id.radioSetup).setEnabled(false);
            findViewById(R.id.radioData).setEnabled(false);
            findViewById(R.id.layoutSetup).setVisibility(View.GONE);
            findViewById(R.id.layoutData).setVisibility(View.GONE);
            writeQueue.flush();
            if(mBluetoothGatt != null){mBluetoothGatt.disconnect();mBluetoothGatt=null;}
            ListData.clear();
            scanLeDevice(true);
        }});


        findViewById(R.id.radioSetup).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            setNotify(UUID_BLE_SERV, UUID_BLE5DATA,UUID_NOTIFY,false);//Stop Notify
            findViewById(R.id.layoutSetup).setVisibility(View.VISIBLE);
            findViewById(R.id.layoutData).setVisibility(View.GONE);
            findViewById(R.id.layoutSetup232).setVisibility(View.GONE);
            findViewById(R.id.layoutSetupName).setVisibility(View.GONE);
            findViewById(R.id.layoutSetupPIN).setVisibility(View.GONE);
            findViewById(R.id.layoutSetupAddress).setVisibility(View.GONE);
        }});
        findViewById(R.id.radioData).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            setNotify(UUID_BLE_SERV, UUID_BLE5DATA,UUID_NOTIFY,true);//Start Notify
            findViewById(R.id.layoutSetup).setVisibility(View.GONE);
            findViewById(R.id.layoutData).setVisibility(View.VISIBLE);
            txValue=new byte[0];
        }});






        findViewById(R.id.btnClear).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v){
            rxValue=new byte[]{};
            handler.sendEmptyMessage(500);//Refresh Display
        }});
        findViewById(R.id.btnWrite).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            write(UUID_BLE_SERV,UUID_BLE5SENT,txValue);//Sent Data to BleDevice
            ((EditText)findViewById(R.id.editTextWrite)).setText("");
        }});

        ((EditText)findViewById(R.id.editTextWrite)).addTextChangedListener(new TextWatcher(){
            @Override public void beforeTextChanged(CharSequence s,int start,int count,int after){}
            @Override public void afterTextChanged(Editable s){
                txValue=s.toString().getBytes();//temporary Data
            }
            @Override public void onTextChanged(CharSequence s,int start,int before,int count){}
        });












        findViewById(R.id.btnSetup232).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            v=findViewById(R.id.layoutSetup232);
            if(v.isShown()){
                v.setVisibility(View.GONE);
            }else{
                read(UUID_BLE_SERV,UUID_BLE5CONF);
                v.setVisibility(View.VISIBLE);
                findViewById(R.id.layoutSetupName).setVisibility(View.GONE);
                findViewById(R.id.layoutSetupPIN).setVisibility(View.GONE);
                findViewById(R.id.layoutSetupAddress).setVisibility(View.GONE);
            }
        }});
        findViewById(R.id.btnWrite232).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            write(UUID_BLE_SERV,UUID_BLE5CONF,txValue);
            findViewById(R.id.btnSetup232).callOnClick();
        }});
        findViewById(R.id.btnSetupName).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            v=findViewById(R.id.layoutSetupName);
            if(v.isShown()){
                v.setVisibility(View.GONE);
            }else{
                read(UUID_BLE_SERV,UUID_BLE5NAME);
                v.setVisibility(View.VISIBLE);
                findViewById(R.id.layoutSetup232).setVisibility(View.GONE);
                findViewById(R.id.layoutSetupPIN).setVisibility(View.GONE);
                findViewById(R.id.layoutSetupAddress).setVisibility(View.GONE);
            }
        }});
        findViewById(R.id.btnWriteName).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            String s=((EditText)findViewById(R.id.editTextName)).getText().toString();
            write(UUID_BLE_SERV,UUID_BLE5NAME,s.getBytes());
            (new AlertDialog.Builder(context)
                    .setTitle("Reboot")
                    .setMessage("Reboot to change Name.")
                    .setPositiveButton("OK", new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){
                            write(UUID_BLE_SERV,UUID_BLE5RBT,new byte[]{ProductType,(byte)0x80});
                        }})
                    .setNegativeButton("Cancel", new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){}})
                    .create()).show();
            findViewById(R.id.btnSetupName).callOnClick();
        }});
        findViewById(R.id.btnSetupPIN).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            v=findViewById(R.id.layoutSetupPIN);
            if(v.isShown()){
                v.setVisibility(View.GONE);
            }else{
                read(UUID_BLE_SERV,UUID_BLE5PIN);
                v.setVisibility(View.VISIBLE);
                findViewById(R.id.layoutSetup232).setVisibility(View.GONE);
                findViewById(R.id.layoutSetupName).setVisibility(View.GONE);
                findViewById(R.id.layoutSetupAddress).setVisibility(View.GONE);
            }
        }});
        findViewById(R.id.btnWritePIN).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            String s=((EditText)findViewById(R.id.editTextPIN)).getText().toString();
            if(s.length()!=6){
                Toast.makeText(getApplication(),"Please Input 6 Numbers.",Toast.LENGTH_LONG).show();
                return;
            }
            txValue=new byte[6];
            txValue[0]=(byte)(s.charAt(0));
            txValue[1]=(byte)(s.charAt(1));
            txValue[2]=(byte)(s.charAt(2));
            txValue[3]=(byte)(s.charAt(3));
            txValue[4]=(byte)(s.charAt(4));
            txValue[5]=(byte)(s.charAt(5));
            write(UUID_BLE_SERV,UUID_BLE5PIN,txValue);
            (new AlertDialog.Builder(context)
                    .setTitle("Reboot")
                    .setMessage("Reboot to change PIN code.")
                    .setPositiveButton("OK", new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){
                            write(UUID_BLE_SERV,UUID_BLE5RBT,new byte[]{ProductType,(byte)0x80});
                        }})
                    .setNegativeButton("Cancel", new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){}})
                    .create()).show();
            findViewById(R.id.btnSetupPIN).callOnClick();
        }});
        findViewById(R.id.btnSetupAddress).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            v=findViewById(R.id.layoutSetupAddress);
            boolean Scan=v.isShown();
            ListData.clear();
            scanLeDevice(!Scan);
            if(Scan){
                v.setVisibility(View.GONE);
            }else{
                read(UUID_BLE_SERV,UUID_BLE5ADDR);
                v.setVisibility(View.VISIBLE);
                findViewById(R.id.layoutSetup232).setVisibility(View.GONE);
                findViewById(R.id.layoutSetupName).setVisibility(View.GONE);
                findViewById(R.id.layoutSetupPIN).setVisibility(View.GONE);
            }
        }});
        findViewById(R.id.btnWriteAddress).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            String s=((EditText)findViewById(R.id.editTextAddress)).getText().toString();
            s=s.replace(":","");
            txValue=new byte[s.length()/2];
            for(int i=0;i<txValue.length;i++){
                int x=Integer.valueOf("0"+s.substring(2*i,2*(i+1)),16);
                txValue[i]=(byte)x;
            }
            write(UUID_BLE_SERV,UUID_BLE5ADDR,txValue);
            if(findViewById(R.id.btnSetup232).isFocusable()) {//SoftwareMode
                findViewById(R.id.btnSetupAddress).callOnClick();
                (new AlertDialog.Builder(context)
                        .setTitle("Reboot")
                        .setMessage("Reboot to Central Mode.")
                        .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                            @Override public void onClick(DialogInterface dialog, int which) {
                                write(UUID_BLE_SERV, UUID_BLE5RBT, new byte[]{ProductType, 0x3A});
                             }})
                        .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
                            @Override public void onClick(DialogInterface dialog, int which) { }})
                        .create()).show();
            }else{
                (new AlertDialog.Builder(context)
                        .setTitle("Reboot")
                        .setMessage("Switch DIP4'ON' then reboot.")
                        .setNegativeButton("OK", new DialogInterface.OnClickListener() {
                            @Override public void onClick(DialogInterface dialog, int which) {
                                findViewById(R.id.btnClose).callOnClick();
                         }})
                        .create()).show();
            }
            findViewById(R.id.layoutSetupAddress).setVisibility(View.GONE);
        }});
        ((ListView)findViewById(R.id.listViewPeripheral)).setAdapter(new ArrayAdapter<String>(this,0,ListData)
        {@SuppressLint("InflateParams") @Override public View getView(int position, View v, ViewGroup parent){
            if(v==null)v=getLayoutInflater().inflate(android.R.layout.simple_list_item_1,null);
            ((TextView)v).setText(getItem(position));
            v.setOnClickListener(new View.OnClickListener()
            {@Override public void onClick(View v){
                String s=((TextView)v).getText().toString();
                ((EditText)findViewById(R.id.editTextAddress)).setText(s.substring(s.indexOf("/")+1));
            }});
            return v;
        }});

        findViewById(R.id.btnReset).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            (new AlertDialog.Builder(context)
                    .setTitle("Reboot")
                    .setMessage("Load Default and reboot.")
                    .setPositiveButton("OK", new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){
                            write(UUID_BLE_SERV,UUID_BLE5RBT,new byte[]{ProductType,0x10});
                        }})
                    .setNegativeButton("Cancel", new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){}})
                    .create()).show();
        }});

        findViewById(R.id.btnReboot).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            (new AlertDialog.Builder(context)
                    .setTitle("Reboot")
                    .setMessage("Reboot to DFU Mode.")
                    .setPositiveButton("OK", new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){
                            write(UUID_BLE_SERV,UUID_BLE5RBT,new byte[]{ProductType,0x1A});
                        }})
                    .setNegativeButton("Cancel", new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){}})
                    .create()).show();
        }});


        findViewById(R.id.btnSetup232BaudRate).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            array232=new String[]{"1200","2400","4800","9600","19200","38400","57600","115200","230400"};
            (new AlertDialog.Builder(context)
                    .setTitle(getString(R.string.setup_baudrate))
                    .setItems(array232,new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){
                            switch(which){//Baud Rate
                                default:txValue[1]=3;
                                case 3:txValue[1]=0x03;break;//0x03:9600
                                case 0:txValue[1]=0x00;break;//0x00:1200
                                case 1:txValue[1]=0x01;break;//0x01:2400
                                case 2:txValue[1]=0x02;break;//0x02:4800
                                case 4:txValue[1]=0x04;break;//0x04:19200
                                case 5:txValue[1]=0x05;break;//0x05:38400
                                case 6:txValue[1]=0x06;break;//0x06:57600
                                case 7:txValue[1]=0x07;break;//0x07:115200
                                case 8:txValue[1]=0x08;break;//0x08:230400
                            }
                            handler.sendEmptyMessage(525);
                        }})
                    .setNegativeButton("Cancel",new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){
                        }})
                    .create()).show();
        }});

        findViewById(R.id.btnSetup232ParityBit).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            array232=new String[]{"No Parity","Even Parity"};
            (new AlertDialog.Builder(context)
                    .setTitle(getString(R.string.setup_paritybit))
                    .setItems(array232,new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){
                            txValue[3]=(byte)(txValue[3]&0xFE|which);
                            handler.sendEmptyMessage(525);
                        }})
                    .setNegativeButton("Cancel",new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){
                        }})
                    .create()).show();
        }});

        findViewById(R.id.btnSetup232HWFC).setOnClickListener(new View.OnClickListener()
        {@Override public void onClick(View v) {
            array232=new String[]{"Disable","Enable"};
            (new AlertDialog.Builder(context)
                    .setTitle(getString(R.string.setup_flowcontrol))
                    .setItems(array232,new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){
                            txValue[3]=(byte)(txValue[3]&0xFD|(which<<1));
                            handler.sendEmptyMessage(525);
                        }})
                    .setNegativeButton("Cancel",new DialogInterface.OnClickListener(){
                        @Override public void onClick(DialogInterface dialog, int which){
                        }})
                    .create()).show();
        }});



    }//end onCreate



    private boolean askPermission(String permission){
        if(android.os.Build.VERSION.SDK_INT < 23)
            return false;
        if(checkSelfPermission(permission) == PackageManager.PERMISSION_GRANTED)
            return false;
        if(!shouldShowRequestPermissionRationale(permission))
            Toast.makeText(getApplication(),getString(R.string.requestPermissions),Toast.LENGTH_LONG).show();
        requestPermissions(new String[]{permission},MY_PERMISSIONS_REQUEST);
        return true;
    }
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch(requestCode){
            case REQUEST_ENABLE_BT:
                if(resultCode == Activity.RESULT_CANCELED){
                    finish();
                }
                break;
        }
    }
    @Override
    public void onResume(){
        super.onResume();
        handler.removeCallbacksAndMessages(null);
        if(!mBluetoothAdapter.isEnabled()){
            startActivityForResult(new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE), REQUEST_ENABLE_BT);
            return;
        }
        if(askPermission(Manifest.permission.ACCESS_COARSE_LOCATION))
            return;

        if(mBluetoothGatt!=null)return;
        scanLeDevice(true);
        findViewById(R.id.radioSetup).setEnabled(false);
        findViewById(R.id.radioData).setEnabled(false);
    }
    @Override
    protected void onPause(){
        super.onPause();
        scanLeDevice(false);
    }
    @Override
    public void onStop() {
        writeQueue.flush();
        if(mBluetoothGatt != null){mBluetoothGatt.disconnect();mBluetoothGatt=null;}
        handler.removeCallbacksAndMessages(null);
        super.onStop();
    }
    @Override
    protected void onDestroy() {
        super.onDestroy();
    }

    // Device scan callback.
    private BluetoothAdapter.LeScanCallback mLeScanCallback = new BluetoothAdapter.LeScanCallback()
    {@Override public void onLeScan(final BluetoothDevice device,int rssi,byte[] scanRecord){
        String deviceAddr = device.getAddress().toString().toUpperCase();
        if(deviceAddr.indexOf(bleFilter)!=0)return;//Address filter
        if(ListData.toString().contains(deviceAddr))return;//skip the same device
        String deviceName = (device.getName()==null?"":device.getName().toString());
        ListData.add(deviceName+"/"+deviceAddr);
        ((BaseAdapter)((ListView)findViewById(R.id.listViewDevice)).getAdapter()).notifyDataSetChanged();
        ((BaseAdapter)((ListView)findViewById(R.id.listViewPeripheral)).getAdapter()).notifyDataSetChanged();
    }};

    private void scanLeDevice(boolean enable){
        if(!enable){
            mBluetoothAdapter.stopLeScan(mLeScanCallback);
        }else if(mBluetoothAdapter.startLeScan(mLeScanCallback)){
            handler.postDelayed(new Runnable(){
                @Override public void run(){
                    scanLeDevice(false);
                }},SCAN_PERIOD);
        }
    }

    private void connectTo(String deviceAddr){
        mBluetoothDevice = mBluetoothAdapter.getRemoteDevice(deviceAddr);
        if(mBluetoothDevice == null)
            return;
        if(mBluetoothGatt != null){mBluetoothGatt.disconnect();mBluetoothGatt.close();mBluetoothGatt=null;}
        mBluetoothGatt = mBluetoothDevice.connectGatt(context, false, btCallback);
        if(mBluetoothGatt == null)
            return;
        mBluetoothGatt.connect();
    }

    private void read(final UUID uuid_serv,final UUID uuid_conf){
        writeQueue.queueRunnable(new Runnable(){@Override public void run(){
            if(mBluetoothGatt==null)return;
            BluetoothGattService serv=mBluetoothGatt.getService(uuid_serv);
            if(serv==null){writeQueue.issue();return;}
            BluetoothGattCharacteristic mCharacteristic=serv.getCharacteristic(uuid_conf);
            mBluetoothGatt.readCharacteristic(mCharacteristic);
        }});
    }
    private void write(final UUID uuid_serv,final UUID uuid_conf,final byte[] value){
        writeQueue.queueRunnable(new Runnable(){@Override public void run(){
            if(mBluetoothGatt==null)return;
            BluetoothGattService serv=mBluetoothGatt.getService(uuid_serv);
            if(serv==null){writeQueue.issue();return;}
            BluetoothGattCharacteristic chara=serv.getCharacteristic(uuid_conf);
            chara.setValue(value);
            mBluetoothGatt.writeCharacteristic(chara);
        }});
    }
    private void setNotify(final UUID uuid_serv,final UUID uuid_data,final UUID uuid_cfg,final boolean enable){
        writeQueue.queueRunnable(new Runnable(){@Override public void run(){
            if(mBluetoothGatt==null)return;
            BluetoothGattService serv=mBluetoothGatt.getService(uuid_serv);
            if(serv==null){writeQueue.issue();return;}
            BluetoothGattCharacteristic config=serv.getCharacteristic(uuid_data);
            mBluetoothGatt.setCharacteristicNotification(config,enable);
            BluetoothGattDescriptor configurCCC=config.getDescriptor(uuid_cfg);
            configurCCC.setValue(enable?BluetoothGattDescriptor.ENABLE_NOTIFICATION_VALUE:BluetoothGattDescriptor.DISABLE_NOTIFICATION_VALUE);
            mBluetoothGatt.writeDescriptor(configurCCC);
        }});
    }
    private String bytesToHex(byte[] bytes){
        if(bytes==null) return "";
        char[] hexArray = "0123456789ABCDEF".toCharArray();
        char[] hexChars = new char[bytes.length * 3];
        for (int j = 0; j < bytes.length; j++) {
            int v = bytes[j] & 0xFF;
            hexChars[j * 3] = hexArray[v >>> 4];
            hexChars[j * 3 + 1] = hexArray[v & 0x0F];
            hexChars[j * 3 + 2] = '\t';
        }
        return new String(hexChars);
    }

    @TargetApi(Build.VERSION_CODES.LOLLIPOP)
    public boolean setMTU(int mtu){
        int retry = 5;
        while( retry>0 ){
            retry=(mBluetoothGatt.requestMtu(mtu)?-1:retry-1);
        }
        return retry<0;
    }
    private final BluetoothGattCallback btCallback=new BluetoothGattCallback(){
        @Override
        public void onConnectionStateChange(BluetoothGatt gatt,	int status, int newState){
            Message m = new Message();
            Bundle bundle = new Bundle();
            String s="";
            if(status != BluetoothGatt.GATT_SUCCESS){//!=0  //133 is GATT_ERROR
                s="Connect Fail-"+gatt.getDevice().getAddress()+"\nState:"+status+"/"+newState;
            }else switch(newState){
                case BluetoothProfile.STATE_CONNECTED://==2
                    if(Build.VERSION.SDK_INT < Build.VERSION_CODES.LOLLIPOP)
                        gatt.discoverServices();
                    else if(!setMTU(512)){ //Default:23(20+3)/max:512(509+3)
                        gatt.discoverServices();
                    }
                    return;
                case BluetoothProfile.STATE_DISCONNECTED://==0
                    s="Off Line-"+gatt.getDevice().getAddress()+"\nState:"+status+"/"+newState;
                    gatt.close();
                    break;
            }
            if(mBluetoothGatt != null){
                mBluetoothGatt.disconnect();
                mBluetoothGatt=null;
                bundle.putString("msg",s);
                m.setData(bundle);
            }
            m.what = 400;
            handler.sendMessage(m);//post message
        }
        @Override
        public void onServicesDiscovered(BluetoothGatt gatt, int status){
            if(status != BluetoothGatt.GATT_SUCCESS) return;
            handler.sendEmptyMessage(200);
            writeQueue.flush();
            rxValue=new byte[]{};
            read(UUID_180A_SERV, UUID_180A_VER);//Read FirmwareVersion
        }
        @Override
        public void onCharacteristicChanged(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic){
            byte[] data=characteristic.getValue();//Got Notify
            byte[] tmpBuf = new byte[rxValue.length+data.length];
            System.arraycopy(rxValue, 0, tmpBuf, 0, rxValue.length);
            System.arraycopy(data, 0, tmpBuf, rxValue.length, data.length);
            rxValue=tmpBuf.clone();
            handler.sendEmptyMessage(500);//Refresh Display
        }
        @Override
        public void onCharacteristicRead(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic, int status){
            writeQueue.issue();
            if(status != BluetoothGatt.GATT_SUCCESS) return;
            UUID uuid=characteristic.getUuid();
            txValue=characteristic.getValue();
            if(UUID_180A_VER.equals(uuid)){//Got FirmwareVersion
                handler.sendEmptyMessage(210);
            }else if(UUID_1800_NAME.equals(uuid)){//Got DeviceName
                handler.sendEmptyMessage(220);
            }else if(UUID_180A_MOD.equals(uuid)){//Got ble version
                handler.sendEmptyMessage(230);
            }else if(UUID_BLE5CONF.equals(uuid)){//Got RS232 Setting
                handler.sendEmptyMessage(525);
            }else if(UUID_BLE5ADDR.equals(uuid)){//Got target Peripheral Device MacAddress
                handler.sendEmptyMessage(530);
            }else if(UUID_BLE5NAME.equals(uuid)){//Got Broadcast Name
                handler.sendEmptyMessage(540);
            }else if(UUID_BLE5PIN.equals(uuid)){//Got PIN Code
                handler.sendEmptyMessage(565);
            }
        }
        @Override
        public void onCharacteristicWrite(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic, int status){
            writeQueue.issue();
            if(UUID_BLE5RBT.equals(characteristic.getUuid())){
                handler.sendEmptyMessage(300);
            }
        }
        @Override
        public void onDescriptorRead(BluetoothGatt gatt, BluetoothGattDescriptor descriptor, int status){
        }
        @Override
        public void onDescriptorWrite(BluetoothGatt gatt, BluetoothGattDescriptor descriptor, int status){
            writeQueue.issue();
        }
        @Override
        public void onReadRemoteRssi(BluetoothGatt gatt, int rssi, int status){
        }
        @Override
        public void onReliableWriteCompleted(BluetoothGatt gatt, int status){
        }
        @Override
        public void onMtuChanged(BluetoothGatt gatt,final int mtu, int status) {
            super.onMtuChanged(gatt, mtu, status);
            gatt.discoverServices();
        }
    };

    private Handler initMessage(){
        return new Handler(new Handler.Callback(){public boolean handleMessage(Message msg)
        {   String s="";int i;
            Bundle bundle = msg.getData();
            switch(msg.what){
                case 100://Connecting
                    if(bleDevice==null || bleDevice.isEmpty())
                        break;
                    String deviceAddr=bleDevice.substring(bleDevice.indexOf("/")+1);
                    connectTo(deviceAddr);
                    s=bleDevice+"\nConnecting...";
                    ((TextView)findViewById(R.id.textViewInfo)).setText(s);
                    findViewById(R.id.listViewDevice).setVisibility(View.GONE);
                    findViewById(R.id.btnClose).setEnabled(false);
                    ((TextView)findViewById(R.id.btnClose)).setText(getString(R.string.connecting));
                    break;
                case 200://Connected
                    s=bleDevice+"\nConnected.";
                    ((TextView)findViewById(R.id.textViewInfo)).setText(s);
                    findViewById(R.id.btnClose).setEnabled(true);
                    ((TextView)findViewById(R.id.btnClose)).setText(getString(R.string.disconnect));
                    break;
                case 300://Reboot
                    Intent intent= getIntent();
                    finish();
                    startActivity(intent);
                    break;
                case 400://Connect fail
                    if(bundle==null)break;
                    s=bundle.getString("msg");
                    if(s==null)break;
                    findViewById(R.id.btnClose).setEnabled(true);
                    ((TextView)findViewById(R.id.btnClose)).setText(getString(R.string.close));
                    ((TextView)findViewById(R.id.textViewInfo)).setText(s);
                    findViewById(R.id.radioSetup).setEnabled(false);
                    findViewById(R.id.radioData).setEnabled(false);
                    findViewById(R.id.layoutSetup).setVisibility(View.GONE);
                    findViewById(R.id.layoutData).setVisibility(View.GONE);
                    break;
                case 210://Display FirmwareVersion
                    for(i=0;i<txValue.length;i++){
                        s+=(char)txValue[i];
                    }
                    s=((TextView)findViewById(R.id.textViewInfo)).getText()+" (Ver"+s;
                    ((TextView)findViewById(R.id.textViewInfo)).setText(s);
//                    read(UUID_1800_SERV, UUID_1800_NAME);//Read DeviceName
                    read(UUID_180A_SERV, UUID_180A_MOD);//Read ble version
                    break;
//                case 220://Got DeviceName
//                    for(i=0;i<txValue.length;i++){
//                        s+=(char)txValue[i];
//                    }
//                    DeviceName=s;
//                    s=((TextView)findViewById(R.id.textViewInfo)).getText()+" "+s+")";
//                    ((TextView)findViewById(R.id.textViewInfo)).setText(s);
//                    break;
                case 230://Got ble version
                    for(i=0;i<txValue.length;i++){
                        s+=(char)txValue[i];
                    }
                    i=s.indexOf("5.0");
                    DeviceName = s.substring(0,i-1);
                    isRS232 = DeviceName.equals("BLE232");

                    s=((TextView)findViewById(R.id.textViewInfo)).getText()+
                            " "+DeviceName+
                            ")["+s.substring(i)+"]";
                    ((TextView)findViewById(R.id.textViewInfo)).setText(s);
                    read(UUID_BLE_SERV,UUID_BLE5CONF);
                    findViewById(R.id.btnSetupName).setVisibility(View.VISIBLE);
                    findViewById(R.id.btnSetupPIN).setVisibility(View.VISIBLE);
                    findViewById(R.id.btnSetupAddress).setVisibility(View.VISIBLE);
                    findViewById(R.id.btnReset).setVisibility(View.VISIBLE);
                    findViewById(R.id.btnSetup232HWFC).setVisibility(isRS232?View.VISIBLE:View.GONE);
                    findViewById(R.id.radioSetup).setEnabled(true);
                    findViewById(R.id.radioData).setEnabled(true);
                    findViewById(R.id.radioData).performClick();
                    break;
                case 500://Display Notify Data
                    for(i=0;i<rxValue.length;i++){
                        s+=(char)rxValue[i];
                    }
                    ((EditText)findViewById(R.id.editTextRead)).setText(s);
                    break;

                case 530://Peripheral Address
                    s=txValue.length!=6?"":String.format("%02X:%02X:%02X:%02X:%02X:%02X",txValue[0],txValue[1],txValue[2],txValue[3],txValue[4],txValue[5]);
                    ((TextView)findViewById(R.id.editTextAddress)).setText(s);
                    break;
                case 540://Name
                    for(i=0;i<txValue.length;i++){
                        char c=(char)txValue[i];
                        if(c=='\0')break;
                        s+=c;
                    }
                    ((TextView)findViewById(R.id.editTextName)).setText(s);
                    break;

                case 525://RS232 (Nordic)
                    if(txValue.length<4)break;
                    ProductType=txValue[0];

                    switch(txValue[1]){//Baud Rate
                        default:txValue[1]=3;
                        case 3:s="9600";break;
                        case 0:s="1200";break;
                        case 1:s="2400";break;
                        case 2:s="4800";break;
                        case 4:s="19200";break;
                        case 5:s="38400";break;
                        case 6:s="57600";break;
                        case 7:s="115200";break;
                        case 8:s="230400";break;
                    }
                    s=getString(R.string.setup_baudrate)+": "+s;
                    ((Button)findViewById(R.id.btnSetup232BaudRate)).setText(s);

                    txValue[2]=0;//Not Used

                    s=getString(R.string.setup_databits)+": 8";
                    ((Button)findViewById(R.id.btnSetup232DataBits)).setText(s);
                    findViewById(R.id.btnSetup232DataBits).setEnabled(false);

                    s=getString(R.string.setup_stopbit)+": 1";
                    ((Button)findViewById(R.id.btnSetup232StopBit)).setText(s);
                    findViewById(R.id.btnSetup232StopBit).setEnabled(false);

//             bit4:BLE Role(0:Peripheral/1:Central) *indication Only
//             bit5:ControlSet(0:Configurable/1:Fixed By Hardware) *indication Only
                    boolean sMode = (txValue[3]&0x20)==0;//Software mode
                    s=sMode?getString(R.string.setup_rs232):getString(R.string.setup_hardware);
                    ((Button)findViewById(R.id.btnSetup232)).setText(s);
                    findViewById(R.id.btnSetup232).setFocusable(sMode);
                    findViewById(R.id.btnSetup232BaudRate).setEnabled(sMode);
                    findViewById(R.id.btnSetup232ParityBit).setEnabled(sMode);
                    findViewById(R.id.btnSetup232HWFC).setEnabled(sMode);
                    findViewById(R.id.btnWrite232).setVisibility(sMode?View.VISIBLE:View.GONE);
                    findViewById(R.id.editText232).setVisibility(sMode?View.VISIBLE:View.GONE);

//             bit0(HardwareMode在bit3):ParityBit:(0:NONE/1:EVEN)
                    s=(txValue[3]&(sMode?0x01:0x08))>0?"Even":"None";
                    s=getString(R.string.setup_paritybit)+": "+s;
                    ((Button)findViewById(R.id.btnSetup232ParityBit)).setText(s);

//             bit1(HardwareMode在bit2):FlowControl(0:Disabled/1:Enabled) *RS232 Only
                    s=(txValue[3]&(sMode?0x02:0x04))>0?"Enabled":"Disabled";
                    s=getString(R.string.setup_flowcontrol)+": "+s;
                    ((Button)findViewById(R.id.btnSetup232HWFC)).setText(s);
                    findViewById(R.id.btnSetup232HWFC).setVisibility(isRS232?View.VISIBLE:View.GONE);

//             bit3:PortType(0:RS485/1:RS422) *Only on RS485/RS422 Product
                    if( !isRS232 && (txValue[3]&0x08)>0 ){
                        s=((TextView)findViewById(R.id.textViewInfo)).getText().toString();
                        ((TextView)findViewById(R.id.textViewInfo)).setText(s.replace(" BLE485)"," BLE422)"));
                    }

                    s=bytesToHex(txValue);
                    ((TextView)findViewById(R.id.editText232)).setText(s);
                    break;

                case 565://PIN code
                    if(txValue.length<6)break;
                    s=String.format("%c%c%c%c%c%c",txValue[0],txValue[1],txValue[2],txValue[3],txValue[4],txValue[5]);
                    ((TextView)findViewById(R.id.editTextPIN)).setText(s);
                    ((EditText)findViewById(R.id.editTextPIN)).selectAll();
                    break;

            }//end switch
            return false;
        }});
    }



}
